<?php
/**
Plugin Name: Featured-video
Plugin URI: http://www.to-wonder.com
Description: Select a featured video instead of an image.
Version: 1.0
Author: Luc Princen (To Wonder)
Author URI: http://www.to-wonder.com

    Copyright 2011 To Wonder Multimedia  (email : luc@to-wonder.com)
*/


add_action('admin_menu', 'fv_meta_register');
add_action('save_post', 'fv_meta_save');


function fv_meta_register(){
	add_meta_box('fv_meta', 'Featured video', 'fv_meta_html', 'post', 'side', 'low');
		
	wp_enqueue_style('fv_video_style', plugins_url().'/featured-video/style.css');
	wp_enqueue_script('fv_video_script', plugins_url().'/featured-video/script.js');
}


function fv_meta_html(){
	wp_nonce_field( plugin_basename( __FILE__ ), 'fv_meta_nonce');
	
	if(isset($_GET['post'])){
		$video = get_post_meta($_GET['post'], 'fv_video', true);
		$v_id = get_post_meta($_GET['post'], 'fv_video_id', true);
		$v_img = get_post_meta($_GET['post'], 'fv_video_img', true);
		if($video == null){
			$video = 'Paste your YouTube embed-code';
		}
	}else{
		$video = '';
	}
	?>
	<?php if($v_img != ''):?>
		<div id="featured_video_preview" style="display:block">
			<img src="<?php echo plugins_url()?>/featured-video/spinner.gif" id="spinner" style="display:none"/>
			<img src="<?php echo $v_img?>" width="100px" id="theimg">
		</div>
	<?php else:?>
		<div id="featured_video_preview">
			<img src="<?php echo plugins_url()?>/featured-video/spinner.gif" id="spinner"/>
		</div>
	<?php endif;?>
	<textarea id="fv_textarea" name="fv_video" style="width:100%;height:100px"><?php echo $video ?></textarea>
	<input type="hidden" name="fv_video_id" value="<?php $v_id?>" id="vid_id"/>
	<input type="hidden" name="fv_video_img" value="<?php $v_img?>" id="vid_img"/>
	<?php
}


function fv_meta_save($post_id){
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
  	return;

	if ( !wp_verify_nonce( $_POST['fv_meta_nonce'], plugin_basename( __FILE__ ) ) )
  	return;

	delete_post_meta($post_id, 'fv_video');
	delete_post_meta($post_id, 'fv_video_id');
	delete_post_meta($post_id, 'fv_video_img');
	
	add_post_meta($post_id, 'fv_video', $_POST['fv_video']);
	add_post_meta($post_id, 'fv_video_id', $_POST['fv_video_id']);
	add_post_meta($post_id, 'fv_video_img', $_POST['fv_video_img']);
	return;
}


/*
	Get-functions:
*/

function has_post_video($pid = null){
	if($pid == null){
		global $post;
		$pid = $post->id;
	}
	
	$id = get_post_meta($pid, 'fv_video_id', true);
	if($id == null || empty($id)){
		return false;
	}else{
		return true;
	}
}

function the_post_video($width = '560', $height = '315'){
	
	global $post;
	$id = get_post_meta($post->ID, 'fv_video_id', true);
	$width = strval($width);
	$height = strval($height);
	
	if($id != null){
		echo '<iframe width="'.$width.'" height="'.$height.'" src="http://www.youtube.com/embed/'.$id.'" frameborder="0" allowfullscreen></iframe>';
	}
}


function get_the_post_video($pid = null, $width = '560', $height = '315'){

	if($pid == null){
		global $post;
		$pid = $post->ID;
	}
	
	$id = get_post_meta($pid, 'fv_video_id', true);
	$width = strval($width);
	$height = strval($height);

	if($id != null){
		return '<iframe width="'.$width.'" height="'.$height.'" src="http://www.youtube.com/embed/'.$id.'" frameborder="0" allowfullscreen></iframe>';
	}
	
	return false;
}

function the_post_video_thumbnail($id = null){
	if($id == null){
		global $post;
		$id = $post->ID;
	}

	$img_src = get_post_meta($id, 'fv_video_img', true);
	if($img_src != null){
		echo '<img src="'.$img_src.'">';
	}	
}

function get_the_post_video_thumbnail($id = null){
	if($id == null){
		global $post;
		$id = $post->ID;
	}

	$img_src = get_post_meta($id, 'fv_video_img', true);
	if($img_src != null){
		return '<img src="'.$img_src.'">';
	}
	
	return false;	
}

function the_post_video_image($id = null){
	if($id == null){
		global $post;
		$id = $post->ID;
	}

	$img_src = get_post_meta($id, 'fv_video_img', true);
	$img_src = str_replace('1.jpg', '0.jpg', $img_src);
	if($img_src != null){
		echo '<img src="'.$img_src.'">';
	}	
	
}

function get_the_post_video_image($id = null){
	if($id == null){
		global $post;
		$id = $post->ID;
	}

	$img_src = get_post_meta($id, 'fv_video_img', true);
	$img_src = str_replace('1.jpg', '0.jpg', $img_src);
	if($img_src != null){
		return '<img src="'.$img_src.'">';
	}
	
	return false;
}


?>